/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskgraph;

import java.util.Set;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.phenotype.Phenotype;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.taskgraph.TaskGraph;

import com.google.inject.Inject;
import com.google.inject.name.Named;

/**
 * {@link TaskGraphEncoding} for {@link TaskGraph}s that <i>may</i> contain <i>abstract</i> tasks,
 * i.e. tasks that need to be instantiated with <i>concrete</i> tasks from a library.
 * 
 * @author diewald
 */
public class AbstractTaskGraphEncoding extends TaskGraphEncoding<TaskGraph> {

	/** Constructor. */
	@Inject
	public AbstractTaskGraphEncoding(@Named("OriginalTaskGraphs") Set<TaskGraph> originalTaskGraphs,
			@Named("HyperPeriod") Double hyperPeriod) {
		super(originalTaskGraphs, hyperPeriod);
	}

	/** Copy Constructor. See {@link TaskGraphEncoding#TaskGraphEncoding(TaskGraphEncoding)}. */
	public AbstractTaskGraphEncoding(AbstractTaskGraphEncoding encoding) {
		super(encoding);
	}

	/** {@inheritDoc} */
	@Override
	public Class<? extends Phenotype> getPTypeToRegister() {
		return AbstractTaskGraphEncoding.class;
	}
}
