/*-------------------------------------------------------------------------+
| Copyright 2014 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.mutate.taskmapping;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.TaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.abstractmapping.AbstractTaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.mutate.MutateOperatorModuleBase;
import org.opt4j.operators.mutate.Mutate;

import com.google.inject.Module;

/**
 * This {@link Module} registers {@link Mutate} operators in Opt4J which manipulate the
 * {@link TaskMappingEncoding}s.
 * 
 * @author huang
 */
// TODO: Generic handling.
public class MutateTaskMappingModule extends MutateOperatorModuleBase {

	/** {@inheritDoc} */
	@Override
	public void config() {
		super.config();

		addOperatorType(AbstractTaskMappingEncoding.class, MutateAllocation.class);
		addOperatorType(AbstractTaskMappingEncoding.class, MutateRedundancyDecrement.class);
		addOperatorType(AbstractTaskMappingEncoding.class, MutateRedundancyIncrement.class);
	}
}
